#pragma once

#include <functional>
#include <windows.h>
#include <flutter/method_channel.h>
#include <flutter/encodable_value.h>

namespace ThreadUtil {
    // Function to initialize the platform thread ID
    void InitializePlatformThreadId();

    // Function to ensure code runs on the platform thread
    void RunOnPlatformThread(std::function<void()> callback);

    // Helper function to invoke method on platform thread
    void InvokeMethodOnPlatformThread(
        flutter::MethodChannel<flutter::EncodableValue>* channel,
        const std::string& method,
        std::unique_ptr<flutter::EncodableValue> arguments);
}
