#ifndef CHANNEL_MANAGER_SERVICE_H
#define CHANNEL_MANAGER_SERVICE_H
#include "../FLTService.h"
#include "Listen.h"
#include <flutter/standard_method_codec.h>
#include <memory>
#include <string>

class ChannelManagerService : public FLTService
{

public:
	ChannelManagerService();

	virtual void onMethodCalled(
		const std::string& method, const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result)
		override;

	// Method handlers
	void setChannelListener(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getChannelMembersInfo(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getChannelMemberList(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getChannelsInfo(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void joinChannel(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void quitChannel(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void changeChannelMute(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void changeChannelMemberMute(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void isJoinChannel(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getUsersInChannel(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);


};

#endif // CHANNEL_MANAGER_SERVICE_H