#ifndef CONVERSATION_MANAGER_SERVICE_H
#define CONVERSATION_MANAGER_SERVICE_H
#include "../FLTService.h"
#include "Listen.h"
#include <flutter/standard_method_codec.h>
#include <memory>
#include <string>

class ConversationManagerService : public FLTService {
public:
	ConversationManagerService();


	virtual void onMethodCalled(
		const std::string& method, const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result)
		override;

	// Method handlers
	void setConversationListener(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getAllConversationList(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getConversationListSplit(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getOneConversation(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getMultipleConversation(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void setConversationDraft(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void hideConversation(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void markConversationMessageAsRead(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getTotalUnreadMsgCount(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getConversationIDBySessionType(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void clearConversationAndDeleteAllMsg(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void deleteConversationAndDeleteAllMsg(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getAtAllTag(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void hideAllConversations(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void searchConversation(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void changeInputStates(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getInputStates(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void setConversation(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void searchConversations(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);


};

#endif // CONVERSATION_MANAGER_SERVICE_H