#ifndef FRIENDSHIP_MANAGER_SERVICE_H
#define FRIENDSHIP_MANAGER_SERVICE_H

#include "../FLTService.h"
#include "Listen.h"
#include <flutter/standard_method_codec.h>
#include <memory>
#include <string>

class FriendshipManagerService : public FLTService
{
public:
	FriendshipManagerService();

	virtual void onMethodCalled(
		const std::string& method, const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result)
		override;

	// Method handlers
	void setFriendListener(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getFriendsInfo(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void addFriend(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getFriendApplicationListAsRecipient(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getFriendApplicationListAsApplicant(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getFriendList(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getFriendListPage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void addBlacklist(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getBlacklist(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void removeBlacklist(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void checkFriend(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void deleteFriend(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void acceptFriendApplication(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void refuseFriendApplication(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void searchFriends(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void updateFriends(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);

};

#endif // FRIENDSHIP_MANAGER_SERVICE_H