#ifndef MESSAGE_MANAGER_SERVICE_H
#define MESSAGE_MANAGER_SERVICE_H
#include "../FLTService.h"
#include "Listen.h"
#include <flutter/standard_method_codec.h>
#include <memory>
#include <string>

class MessageManagerService : public FLTService {
public:
	MessageManagerService();

	virtual void onMethodCalled(
		const std::string& method, const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result)
		override;

	// Method handlers
	void setAdvancedMsgListener(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void sendMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void revokeMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void editMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void deleteMessageFromLocalStorage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void deleteMessageFromLocalAndSvr(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void deleteAllMsgFromLocal(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void deleteAllMsgFromLocalAndSvr(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void insertSingleMessageToLocalStorage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void insertGroupMessageToLocalStorage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void markMessagesAsReadByMsgID(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void typingStatusUpdate(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createTextMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createTextAtMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createImageMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createImageMessageFromFullPath(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createSoundMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createSoundMessageFromFullPath(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createVideoMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createVideoMessageFromFullPath(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createFileMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createFileMessageFromFullPath(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createMergerMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createForwardMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createLocationMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createCustomMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createQuoteMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createCardMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createFaceMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createAdvancedTextMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createAdvancedQuoteMessage(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void searchLocalMessages(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void clearConversationAndDeleteAllMsg(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getAdvancedHistoryMessageList(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getAdvancedHistoryMessageListReverse(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void findMessageList(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void setMessageLocalEx(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void setAppBadge(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void sendMessageNotOss(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createImageMessageByURL(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createSoundMessageByURL(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createVideoMessageByURL(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void createFileMessageByURL(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void fetchSurroundingMessages(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void setCustomBusinessListener(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);


};

#endif // MESSAGE_MANAGER_SERVICE_H