#ifndef USER_MANAGER_SERVICE_H
#define USER_MANAGER_SERVICE_H

#include "../FLTService.h"
#include "Listen.h"
#include <flutter/standard_method_codec.h>
#include <memory>
#include <string>

class UserManagerService : public FLTService {
public:
	UserManagerService();

	virtual void onMethodCalled(
		const std::string& method, const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result)
		override;

	// Method handlers
	void setUserListener(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getUsersInfo(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void setSelfInfo(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getSelfUserInfo(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void subscribeUsersStatus(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void unsubscribeUsersStatus(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getSubscribeUsersStatus(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
	void getUserStatus(
		const flutter::EncodableMap* arguments,
		std::shared_ptr<flutter::MethodResult<flutter::EncodableValue>> result);


};

#endif // USER_MANAGER_SERVICE_H